<!DOCTYPE html>
<html>

<head>
  <meta charset="UTF-8">
  <title>Classwork</title>

  <script>
    /*
      Задание:
        1. Используя интерфейс который есть на страничке, написать визуальный
        конструктор обектов используя значение key-value, которые вводятся в
        соответствующие поля в форме.

        2. Каждый созданый обьект выводить в тег code после добавления каждого
        нового поля. Т.е мы должны визуально видить в каком состоянии наши обьекты
        сейчас

        3. По нажатию кнопки Combine Objects! два обьекта должны обьедениться
        используя метод Object.assing или spread operator и вывестись на стринчку.

        * Изменять HTML можно.

    */
    document.addEventListener("DOMContentLoaded", function () {

      const codeFirst = document.getElementById("codeFirst");
      const codeSecond = document.getElementById("codeSecond");

      const formFirst = document.getElementById("formFirst");
        formFirst.addEventListener('submit', sendObjFirstClick);
      const keyFirst = document.getElementById("keyFirst");
      const valueFirst = document.getElementById("valueFirst");

      const formSecond = document.getElementById("formSecond");
        formSecond.addEventListener('submit', sendObjSecondClick);
      const keySecond = document.getElementById("keySecond");
      const valueSecond = document.getElementById("valueSecond");

      const btnCombine = document.getElementById("btnCombine");
        btnCombine.addEventListener('click', combineClick)
      const result = document.getElementById("result");

      let objFirst = {};
      let objSecond = {};

      function sendObjFirstClick(e){
        e.preventDefault();
        createObject(objFirst, keyFirst.value, valueFirst.value);
        viewCode(codeFirst, objFirst);
      }

      function sendObjSecondClick(e){
        e.preventDefault();
        createObject(objSecond, keySecond.value, valueSecond.value);
        viewCode(codeSecond, objSecond);
      }

      function combineClick(e){
        let objClone = {...objFirst, ...objSecond}; // assing
        viewCode(result, objClone);
      }

      function createObject(obj, key, value){
        obj[key] = value;
      }
      
      function viewCode(target, obj){
        target.innerText = JSON.stringify(obj, "", '\t');
      }
    })
  </script>
</head>

<body>
  <div class="wrap">
    <div class="assigned">
      <form class="ObjForm" id="formFirst">
        <input id="keyFirst" name="key" placeholder="Enter your key" />
        <input id="valueFirst" name="value" placeholder="Enter your value" />
        <button type="submit">Send</button>
      </form>
      <div class="createResult">
        <header>
          Created Object
        </header>
        <div class="createdObj">
          <code id="codeFirst">
              {
              }
            </code>
        </div>
      </div>
    </div>

    <div class="assigned">
      <form class="ObjForm" id="formSecond">
        <input id="keySecond" name="key" placeholder="Enter your key" />
        <input id="valueSecond" name="value" placeholder="Enter your value" />
        <button type="submit">Send</button>
      </form>
      <div class="createResult">
        <header>
          Created Object
        </header>
        <div class="createdObj">
          <code id="codeSecond">
                {
                  <!-- id:123,
                  b:'test',
                  demo:'test2' -->
                }
              </code>
        </div>
      </div>
    </div>
  </div>
  <div class="resultBlock">
    <button id="btnCombine">Combine Objects!</button>
    <h3> Result: </h3>
    <div id="result"></div>
  </div>

  <script>

  </script>
  <style>
    .wrap {
      width: 800px;
      display: flex;
    }

    .ObjForm,
    .resultBlock {
      display: flex;
      flex-direction: column;
      align-items: flex-start;
      box-sizing: border-box;
      padding: 10px 20px;
    }

    .assigned {
      width: 300px;
      display: flex;
    }

    .createResult header {
      font-weight: 700;
    }
  </style>
</body>

</html>